import { cloneDeep } from "lodash"
import NmakeGlobal from "../interface/NmakeGlobal"
import printDebug from "../Tools/DebugPrint"

const project = (name:string,callback:Function) =>{
    const oldGlobal = (global as any).nmake as unknown as NmakeGlobal
    const nGlobal = cloneDeep(((global as any).nmake as unknown as NmakeGlobal));
    (global as any).nmake = nGlobal
    printDebug("adding project :"+name)
    callback()
    (global as any).nmake = oldGlobal
}

export default project