import { cloneDeep } from "lodash"
import NmakeGlobal from "../interface/NmakeGlobal"
import printDebug from "./DebugPrint"

export const Global = global as any
let globalNmakeStacks = Global.globalStacks as NmakeGlobal[]

export const pushGlobalStack = () =>{
    if(!Global.globalStacks){Global.globalStacks = [];globalNmakeStacks = Global.globalStacks as NmakeGlobal[]}
    printDebug("pushing global stack")
    globalNmakeStacks.push(Global.nmake)
    Global.nmake = cloneDeep(Global.nmake)
}

export const popGlobalStack = ()=>{
    Global.nmake = globalNmakeStacks[globalNmakeStacks.length-1]
    globalNmakeStacks.pop()
}

export const  getGlobalNmake=():NmakeGlobal=>{
    return Global.nmake
}